﻿package
{
	import flash.geom.Matrix;
	import flash.utils.*;
	import flash.display.*;
	import flash.events.*;
	import flash.ui.*;
	import org.papervision3d.materials.special.ParticleMaterial;
	import org.papervision3d.objects.special.ParticleField;
	
	import org.papervision3d.view.*;
	import org.papervision3d.core.math.*;
	import org.papervision3d.cameras.*;
	import org.papervision3d.render.*;
	import org.papervision3d.materials.utils.*;
	import org.papervision3d.materials.*;
	import org.papervision3d.materials.shadematerials.*;
	import org.papervision3d.objects.primitives.*;
	import org.papervision3d.objects.*;
	import org.papervision3d.lights.*;
	import org.papervision3d.scenes.*;

	import jiglib.math.*;
	import jiglib.geometry.*;
	import jiglib.physics.*;
	import jiglib.physics.constraint.*;

	public class Hoge extends BasicView
	{
		static private const OBJ_MAX:uint = 7;
		
		private var ballBody:Vector.<JSphere> = new Vector.<JSphere>(OBJ_MAX, true);
		private var balls:Vector.<Sphere> = new Vector.<Sphere>(OBJ_MAX, true);
		
		private var keyRight    :Boolean = false;
		private var keyLeft     :Boolean = false;
		private var keyForward  :Boolean = false;
		private var keyReverse  :Boolean = false;
		private var keyUp       :Boolean = false;

		private var light:PointLight3D = new PointLight3D()
		private var springCamera:SpringCamera3D = new SpringCamera3D();
		private var cameraTarget:DisplayObject3D = new DisplayObject3D();

		public function Hoge()
		{
			stage.quality = StageQuality.MEDIUM
			stage.addEventListener( KeyboardEvent.KEY_DOWN, keyDownHandler );
			stage.addEventListener( KeyboardEvent.KEY_UP, keyUpHandler );
			light.y = 500;
			light.z = 200;
			PhysicsSystem.getInstance().SetGravity(new JNumber3D(0, -30, 0))

			var materia1 :MaterialsList = new MaterialsList();
			materia1.addMaterial(new WireframeMaterial(0xFFFFFF, .3), "all");
			var groundSkin:Cube = new Cube(materia1, 2000, 2000, 50, 4, 1, 4);
			scene.addChild(groundSkin);

			var ground:JBox = new JBox(groundSkin, false, 2000, 2000, 50);
			PhysicsSystem.getInstance().AddBody(ground);
			ground.Material.Restitution = 0.6;
			ground.Material.StaticFriction = 0.9;
			
			for (var i:int = 0; i < OBJ_MAX; i++)
			{
				var color:uint = (i == 0) ? 0xFFFFFF : 0x333333;
				balls[i] = new Sphere(new FlatShadeMaterial(light, color), 30, 6, 6);
				scene.addChild(balls[i]);
				ballBody[i] = new JSphere(balls[i], true, 30);
				ballBody[i].setMass(5);
				ballBody[i].MoveTo(
					new JNumber3D(
						Math.random() * 1000 - 500, 200, Math.random() * 1000 - 500), 
						JMatrix3D.IDENTITY);
				PhysicsSystem.getInstance().AddBody(ballBody[i]);
			}
			ballBody[i-1].Material.Restitution = 0.9;
			
			springCamera.target = cameraTarget
			springCamera.mass = 7;
			springCamera.damping = 7;
			springCamera.stiffness = 1;
			springCamera.positionOffset = new Number3D(0, 300, -300);
			
			startRendering()
			
			// ついでにパーティクル
			//var particles:ParticleField = new ParticleField(new ParticleMaterial(0xFFFFFF, 1), 5000, 1, 4000, 4000, 4000);
            //scene.addChild( particles );
			
			// ついでに背景の作成 不要なら以下4行を削除ください
			var bgMatrix:Matrix = new Matrix();
			bgMatrix.rotate(90 * Math.PI / 180);
			graphics.beginGradientFill("linear", [0xFFFFFF, 0x001122], [100, 100], [0, 255], bgMatrix);
			graphics.drawRect(0, 0, stage.stageWidth, stage.stageHeight);
		}


		private function keyDownHandler(event:KeyboardEvent):void
		{
			switch(event.keyCode)
			{
				case Keyboard.UP:
					keyForward = true;
					keyReverse = false;
					break;

				case Keyboard.DOWN:
					keyReverse = true;
					keyForward = false;
					break;

				case Keyboard.LEFT:
					keyLeft = true;
					keyRight = false;
					break;

				case Keyboard.RIGHT:
					keyRight = true;
					keyLeft = false;
					break;
					
				case Keyboard.SPACE:
					keyUp = true;
					break;
			}
		}
		
		private function keyUpHandler(event:KeyboardEvent):void
		{
			switch(event.keyCode)
			{
				case Keyboard.UP    : keyForward = false; break;
				case Keyboard.DOWN  : keyReverse = false; break;
				case Keyboard.LEFT  : keyLeft    = false; break;
				case Keyboard.RIGHT : keyRight   = false; break;
				case Keyboard.SPACE : keyUp      = false; break;       
			}
		}
		
		override protected function onRenderTick(event:Event = null):void 
		{
			if(keyLeft)		ballBody[0].AddWorldForce(new JNumber3D(-100,0,0),ballBody[0].CurrentState.Position);
			if(keyRight)	ballBody[0].AddWorldForce(new JNumber3D(100,0,0),ballBody[0].CurrentState.Position);
			if(keyForward)	ballBody[0].AddWorldForce(new JNumber3D(0,0,100),ballBody[0].CurrentState.Position);
			if(keyReverse)	ballBody[0].AddWorldForce(new JNumber3D(0,0,-100),ballBody[0].CurrentState.Position);
			if(keyUp)		ballBody[0].AddWorldForce(new JNumber3D(0,300,0),ballBody[0].CurrentState.Position);
			
			for (var i:String in ballBody)
			{
				if (ballBody[i].CurrentState.Position.y < -200)
					ballBody[i].MoveTo(new JNumber3D(0, 240 + (60 * Number(i) + 60), 0), JMatrix3D.IDENTITY);
			}
			
			cameraTarget.copyPosition(balls[0]);
			light.copyPosition(balls[0]);
			light.moveUp(50);
			
			PhysicsSystem.getInstance().Integrate(0.1);
			renderer.renderScene(scene, springCamera, viewport);
		}
	}
}